<!DOCTYPE html>
<html lang="en">

<head>
  <title>Bootstrap Example</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
  <div class="container">
    <div class="row d-flex justify-content-center mt-4">
      <h2>Order Detail!!!</h2>
    </div>
    <div class="row">
      <div class="col-sm-6">
        <div class="row form-group">
          <div class="col-sm-4 text-right">
            <label for="order-code">Order Code</label>
          </div>
          <div class="col-sm-8">
            <input type="text" id="order-code" class="form-control">
          </div>
        </div>
        <div class="row form-group">
          <div class="col-sm-4 text-right">
            <label for="duong-kinh-pizza">Đường kính Pizza</label>
          </div>
          <div class="col-sm-8">
            <input type="text" id="duong-kinh-pizza" class="form-control">
          </div>
        </div>
        <div class="row form-group">
          <div class="col-sm-4 text-right">
            <label for="drinks">Đồ uống</label>
          </div>
          <div class="col-sm-8">
            <select name="drinks" id="drinks" class="form-control">
              <option value="all">Chọn đồ uống</option>
            </select>
          </div>
        </div>
        <div class="row form-group">
          <div class="col-sm-4 text-right">
            <label for="voucher-id">Voucher ID</label>
          </div>
          <div class="col-sm-8">
            <input type="text" id="voucher-id" class="form-control">
          </div>
        </div>
        <div class="row form-group">
          <div class="col-sm-4 text-right">
            <label for="salad">Salad</label>
          </div>
          <div class="col-sm-8">
            <input type="text" id="salad" class="form-control">
          </div>
        </div>
        <div class="row form-group">
          <div class="col-sm-4 text-right">
            <label for="discount">Giảm giá</label>
          </div>
          <div class="col-sm-8">
            <input type="text" id="discount" class="form-control">
          </div>
        </div>
        <div class="row form-group">
          <div class="col-sm-4 text-right">
            <label for="email">Email</label>
          </div>
          <div class="col-sm-8">
            <input type="text" id="email" class="form-control">
          </div>
        </div>
        <div class="row form-group">
          <div class="col-sm-4 text-right">
            <label for="address">Địa chỉ</label>
          </div>
          <div class="col-sm-8">
            <input type="text" id="address" class="form-control">
          </div>
        </div>
        <div class="row form-group">
          <div class="col-sm-4 text-right">
            <label for="status">Trạng thái đơn hàng</label>
          </div>
          <div class="col-sm-8">
            <select name="status" id="status" class="form-control">
              <option value="all">Trạng thái</option>
            </select>
          </div>
        </div>
        <div class="row form-group">
          <div class="col-sm-4 text-right">
            <label for="updated-date">Ngày cập nhật</label>
          </div>
          <div class="col-sm-8">
            <input type="text" id="updated-date" class="form-control">
          </div>
        </div>
      </div>
      <div class="col-sm-6">
        <div class="row form-group">
          <div class="col-sm-4 text-right">
            <label for="combo-size">Cỡ combo</label>
          </div>
          <div class="col-sm-8">
            <select name="combo-size" id="combo-size" class="form-control">
              <option value="all">Chọn cỡ Combo (Combo size)</option>
            </select>
          </div>
        </div>
        <div class="row form-group">
          <div class="col-sm-4 text-right">
            <label for="suon-nuong">Sườn nướng(miếng)</label>
          </div>
          <div class="col-sm-8">
            <input type="text" id="suon-nuong" class="form-control">
          </div>
        </div>
        <div class="row form-group">
          <div class="col-sm-4 text-right">
            <label for="drink-amount">Số lượng nước uống</label>
          </div>
          <div class="col-sm-8">
            <input type="text" id="drink-amount" class="form-control">
          </div>
        </div>
        <div class="row form-group">
          <div class="col-sm-4 text-right">
            <label for="pizza-type">Loại Pizza</label>
          </div>
          <div class="col-sm-8">
            <select name="pizza-type" id="pizza-type" class="form-control">
              <option value="all">Chọn loại pizza</option>
            </select>
          </div>
        </div>
        <div class="row form-group">
          <div class="col-sm-4 text-right">
            <label for="price">Thành tiền</label>
          </div>
          <div class="col-sm-8">
            <input type="text" id="price" class="form-control">
          </div>
        </div>
        <div class="row form-group">
          <div class="col-sm-4 text-right">
            <label for="fullname">Họ và tên</label>
          </div>
          <div class="col-sm-8">
            <input type="text" id="fullname" class="form-control">
          </div>
        </div>
        <div class="row form-group">
          <div class="col-sm-4 text-right">
            <label for="phone">Số điện thoại</label>
          </div>
          <div class="col-sm-8">
            <input type="text" id="phone" class="form-control">
          </div>
        </div>
        <div class="row form-group">
          <div class="col-sm-4 text-right">
            <label for="message">Lời nhắn</label>
          </div>
          <div class="col-sm-8">
            <input type="text" id="message" class="form-control">
          </div>
        </div>
        <div class="row form-group">
          <div class="col-sm-4 text-right">
            <label for="created-order-date">Ngày tạo đơn</label>
          </div>
          <div class="col-sm-8">
            <input type="text" id="created-order-date" class="form-control">
          </div>
        </div>
      </div>
    </div>
    <div class="row form-group"> <!-- Hàng chứa nút Button -->
      <div class="col-2 text-right">
      </div>
      <div class="col-4">
        <button id="btn-confirm" class="btn btn-group btn-success">Confirm</button>
        <button id="btn-cancel" class="btn btn-group btn-info">Cancel</button>
      </div>
    </div>
  </div>
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    // Khai báo biến global để lưu giá trị Id và OrderCode truyền sang từ Query String
    var gOrderId = '';
    var gOrderCode = '';
    // Khai báo biến lưu tên file html điều hướng khi nhấn vào button 'Chi tiết'
    const gINDEX_LIST_VIEW_PAGE = "./31.20.html.html";
    // Khai báo các biến kiểm tra trạng thái khi gửi request đến Server
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders"

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // Hàm tải lại trang và hiển thị dữ liệu trên Website
    function onPageLoading() {
      // 1. Đọc dữ liệu (đọc từ query string)
      readData();
      // 2. Kiểm tra dữ liệu
      var vIsValid = validateQueryString();
      if(vIsValid) {
        // 3. Gọi API
        var vXmlHttp = new XMLHttpRequest();
        callAPIToGetOrderData(vXmlHttp, gOrderCode);
        // kiểm tra trạng thái trả về từ Server để tiếp tục thực hiện việc hiển thị dữ liệu lên Web
        vXmlHttp.onreadystatechange = function () {
          if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
              // 4. Hiển thị thông tin chi tiết của User lên form
              showOrderDetailByOrderId(vXmlHttp.responseText);
          }
        }
      }
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm lấy OrderId và OrderCode từ query string
    function readData() {
      // Get data from query string
      var vUrlString = window.location.href;
      var vUrl = new URL(vUrlString);
      // Get parameters
      gOrderId = vUrl.searchParams.get("id");
      gOrderCode = vUrl.searchParams.get("orderCode");
    }

    // Hàm kiểm tra OrderId và OrderCode được truyền từ query string
    // input: <no>
    // output: true/false -> false khi OrderId và OrderCode rỗng hoặc null
    function validateQueryString() {
      var vChecked = true;
      if(gOrderId == '' || gOrderCode == '' || gOrderId== null || gOrderCode == null) {
        alert("Order không hợp lệ!");
        // quay lại trang danh sách indexListView
        var vUrlSiteToOpen = gINDEX_LIST_VIEW_PAGE;
        window.location.href = vUrlSiteToOpen;
        vChecked = false;
      }
      return vChecked;
    }

    // Hàm gọi API để lấy tất cả thông tin Order (19 dữ liệu)
    // input: đối tượng XMLHttpRequest và Order Code
    // output: <no>
    function callAPIToGetOrderData(paramXmlHttp, paramOrderCode) {
      paramXmlHttp.open("GET", gBASE_URL + "/" + paramOrderCode, true);
      paramXmlHttp.send();
    }

    // Hàm hiển thị thông tin Order
    // input: chuỗi JSON responseText trả về từ Server
    // output: <no>
    function showOrderDetailByOrderId(paramOrderJSON) {
      // Chuyển đổi JSON String sang OBject để xử lý hiển thị dữ liệu
      var vOrderObject = JSON.parse(paramOrderJSON);
      // Truy xuất các phần tử HTML trên form
      var vOrderCode = document.getElementById("order-code");
      var vDuongKinhPizza = document.getElementById("duong-kinh-pizza");
      var vDrink = document.getElementById("drinks");
      var vVoucherId = document.getElementById("voucher-id");
      var vSalad = document.getElementById("salad");
      var vDiscount = document.getElementById("discount");
      var vEmail = document.getElementById("email");
      var vAddress = document.getElementById("address");
      var vStatus = document.getElementById("status");
      var vUpdatedDate = document.getElementById("updated-date");
      var vComboSize = document.getElementById("combo-size");
      var vSuonNuong = document.getElementById("suon-nuong");
      var vDrinkAmount = document.getElementById("drink-amount");
      var vPizzaType = document.getElementById("pizza-type");
      var vPrice = document.getElementById("price");
      var vFullname = document.getElementById("fullname");
      var vPhone = document.getElementById("phone");
      var vMessage = document.getElementById("message");
      var vCreatedOrderDate = document.getElementById("created-order-date");
      
      // Gán giá trị từ đối tượng Order vào các thẻ HTML
      vOrderCode.value = vOrderObject.orderCode;
      vDuongKinhPizza.value = vOrderObject.duongKinh;
      vDrink.options[vDrink.selectedIndex].textContent = vOrderObject.idLoaiNuocUong;
      vVoucherId.value = vOrderObject.idVourcher;
      vSalad.value = vOrderObject.salad;
      vDiscount.value = vOrderObject.giamGia;
      vEmail.value = vOrderObject.email;
      vAddress.value = vOrderObject.diaChi;
      vStatus.options[vStatus.selectedIndex].textContent = vOrderObject.trangThai;
      vUpdatedDate.value = vOrderObject.ngayCapNhat;
      vComboSize.options[vComboSize.selectedIndex].textContent = vOrderObject.kichCo;
      vSuonNuong.value = vOrderObject.suon;
      vDrinkAmount.value = vOrderObject.soLuongNuoc;
      vPizzaType.options[vPizzaType.selectedIndex].textContent = vOrderObject.loaiPizza;
      vPrice.value = vOrderObject.thanhTien;
      vFullname.value = vOrderObject.hoTen;
      vPhone.value = vOrderObject.soDienThoai;
      vMessage.value = vOrderObject.loiNhan;
      vCreatedOrderDate.value = vOrderObject.ngayTao;
    }
  </script>
</body>

</html>